#DEFINE		WHITESPACE	CHR(32)+CHR(0)+CHR(9)+CHR(10)+CHR(11)+CHR(12)+CHR(13)+CHR(26)

FUNCTION xINLIST

**  Pradip Acharya, Gencom Software, July, 2002
**  
**  Case, Type and Set Exact independent. 
**  Trimmed lengths must be equal.
**  Max 1 + 26 arguments in list.

LPARAMETERS p1, p2, p3, p4, p5, p6, p7, p8, p9,  ;
            p10,p11,p12,p13,p14,p15,p16,p17,p18, ;
            p19,p20,p21,p22,p23,p24,p25,p26,p27

	local npar, i, temp, item, NullFlag, p1type
	npar = PARAMETERS()
	if ISNULL( m.p1 )
		return NULL
	endif

	p1type = VARTYPE(m.p1)
	if m.p1type $ "CM"
		temp = UPPER(xTRIM( m.p1 ))
		for i = 2 to m.npar
			item = EVAL("m.p" + ALLTRIM(STR(m.i)))
			DO CASE
			case ISNULL( m.item )
				NullFlag = NULL

			case (VARTYPE( m.item ) $ "CM") and ;
			 (UPPER(xTRIM( m.item )) == m.temp)
				return

			ENDCASE
		endfor
	else
		for i = 2 to m.npar
			item = EVAL("m.p" + ALLTRIM(STR(m.i, 2)))
			DO CASE
			case ISNULL( m.item )
				NullFlag = NULL

			case (VARTYPE( m.item ) == m.p1type) and ;
				 (m.item = m.p1)
				return

			ENDCASE
		endfor
	endif
return m.NullFlag


FUNCTION xEQ  && special case of xINLIST
LPARAMETERS p1arg, p2arg

**  Pradip Acharya, Gencom Software, July, 2002
**  
**  Case, Type and Set Exact independent.
**  Returns .T., .F. or NULL

	if ISNULL( m.p1arg ) or ISNULL( m.p2arg )
		return NULL
	endif
	local temp
	temp = VARTYPE( m.p1arg )
	if not (m.temp == VARTYPE( m.p2arg ))
		return .f.
	endif
	if m.temp == "C"
		return (UPPER(xTRIM(m.p1arg)) == ;
		        UPPER(xTRIM(m.p2arg)))
	endif
return (m.p1arg = m.p2arg)


FUNCTION xASCAN

**  Pradip Acharya, Gencom Software, July, 2002
**  
**  Case, Type and Set Exact independent. 
**  Extra 5th argument for ATC sliding match, 
**  else, trimmed lengths must be equal.
**  
**  xASCAN(@m.MyArray, "PREPAID",,,"Slide")

LPARAMETERS p1array, p2what, p3i1, p4ntot, p5atc
	extern array p1array
	local i, temp, i1, i2, vType, LookFor
	i2 = ALEN( p1array )
	DO CASE
	case empty( m.p3i1 )
		i1 = 1

	case m.p3i1 > m.i2
		return 0

	other
		i1 = m.p3i1

	ENDCASE
	if not empty( m.p4ntot )
		temp = m.i1 + m.p4ntot - 1
		if m.temp < m.i2
			i2 = m.temp
		endif
	endif

	vType = VARTYPE( m.p2what )
	if m.vType $ "CM"
		LookFor = UPPER(xTRIM( m.p2what ))
	endif
	DO CASE
	case not (m.vType $ "CM")
		for i = m.i1 to m.i2
			if (VARTYPE(p1array( m.i )) == m.vType) and ;
			   (p1array( m.i ) = m.p2what)
				return m.i
			endif
		endfor

	case empty( LookFor )
		for i = m.i1 to m.i2
			if (VARTYPE(p1array( m.i )) $ "CM") and ;
		        empty(xTRIM(p1array( m.i )))
				return m.i
			endif
		endfor

	case empty( m.p5atc )
		for i = m.i1 to m.i2
			if (VARTYPE(p1array( m.i )) $ "CM") and ;
		   (UPPER(xTRIM(p1array( m.i ))) == m.LookFor)
				return m.i
			endif
		endfor

	other
		for i = m.i1 to m.i2
			if (VARTYPE(p1array( m.i )) $ "CM") and ;
		       (ATC(m.LookFor, p1array( m.i )) > 0)
				return m.i
			endif
		endfor

	ENDCASE
return 0


FUNCTION xADEL

**  Pradip Acharya, Gencom Software, July, 2002
**  
**  Case, Type and Set Exact independent. 
**  3rd argument for ATC sliding match, 
**  else, trimmed lengths must be equal.
**  If match found, delete first occurrence
**  Eliminate resulting .F. value at bottom
**
**  xADEL(@m.MyArray, "DELIVER", "Slide")
**
**  If deleted, returns .T., else .F.
**

lpar ap1, p2LookFor, p3atc
	external array ap1
	local i
	i = xASCAN(@m.ap1, m.p2LookFor,,,p3atc)
	if empty( m.i )
		return .f.
	endif

	ADEL(ap1, m.i)

	if ALEN( ap1 ) > 1
		dime ap1(ALEN( ap1 ) - 1)
	else
		dime ap1( 1 )
		ap1( 1 ) = .f.
	endif
return


FUNCTION xTRIM
lpar p1cString
**  
**  Pradip Acharya, Gencom Software, July, 2002
**  
**  Unequivocally remove leading and 
**  trailing white space including 
**  linefeeds etc.
**  
	if not (VARTYPE(m.p1cString) $ "CM")
		return ""
	endif

	local liI, liJ, liL
	liL = LEN(m.p1cString)
	liI = 0
	for liJ = 1 to m.liL
		if .NOT.(SUBST(m.p1cString, m.liJ, 1) $ WHITESPACE)
			liI = m.liJ
			EXIT
		endif
	endfor
	if m.liI = 0
		p1cString = ""
		return ""
	endif
	for liJ = m.liL to m.liI STEP -1
		if .NOT.(SUBST(m.p1cString, m.liJ, 1) $ WHITESPACE)
			EXIT
		endif
	endfor
	liL = m.liJ - m.liI + 1
	p1cString = SUBST(m.p1cString, m.liI, m.liL)
return m.p1cString
