* flag undel email.prg

* purpose is to go through EMAILBAD.DBF (came from a PST)
* find the original recipient
* look for that recipient in CUST.DBF
* set a flag in CUST.DBF and identify the message

* for each standard subject line in EMAILBAD.DBF:
* start by looking for string
* get the position of the end of that string
* then start looking for an "@" char.
* once found, look forward for a non "A-Z0-9" char, also look back for the same
* once found that string, look for that string in CUST.DBF
* if found, mark CUST.cDelete with "BAD" and the reason, 

* STEP 1:
* In Outlook, File | Import/Export | Export to a File | Microsoft FoxPro | Select folder
* select the RemoveBadAddr, send to EmailBadAddr

* STEP 2: 
* parse EMAILBAD.DBF for the bad address

* STEP 3:
* look for bad address in CUST.DBF

* this JUST handles EMAILBAD, parsing bad addresses
close data

* replace importance with the guess at the email address
if used("EMAILBAD")
 select EMAILBAD
else
 use EMAILBAD in 0
 select EMAILBAD
endif
m.liNumTotalRecs = reccount()

scan 
wait window nowait "This many records to go: " + transform(m.liNumTotalRecs - recno())
m.lcSubject = EMAILBAD.Subject
m.lcBody = EMAILBAD.Body
m.lcFromName = EMAILBAD.FromName

m.lcReason = "-"
m.lcStringToLookIn = "-"
m.lcStringPre = "-"
m.lcStringDelim1 = "-"
m.lcStringDelim2 = "-"

do case
case "@" $ m.lcSubject 
 * don't parse m.lcBody because we just have to look at the Subject line!
 *" Subject line contains "@" 
 ** (1.4% had DELIVERY FAILURE: <address> lines)"
 m.lcStringToLookIn = m.lcSubject
 m.lcStringPre = ""
 m.lcStringDelim1 = "("
 m.lcStringDelim2 = ")"
 m.lcReason = "@ in subject line"

case m.lcSubject = "Undeliverable Message" and m.lcFromName = "CompuServe Postmaster"
 * parsing out the middle of the body for for <name@compuserve.com>
 m.liPositionEnd = at("Sender: remove@hentzenwerke.com", m.lcBody) + 32
 m.lcReason = "Undel/CompuServe PM/parsebody"
 m.lcStringToLookIn = substr(m.lcBody, m.liPositionEnd)
 m.lcStringPre = "for"
 m.lcStringDelim1 = "<"
 m.lcStringDelim2 = ">"

case m.lcSubject = "Mail System Error - Returned Mail"
 do case
 case "Recipient: <" $ m.lcbody and "Reason:    " $ m.lcbody
  m.lcReason = ["Recipient: <" $ m.lcbody and "Reason:    " $ m.lcbody]
  m.lcStringToLookIn = m.lcBody
  m.lcStringPre = "Recipient:"
  m.lcStringDelim1 = "<"
  m.lcStringDelim2 = ">"
 case "The following recipients did not receive this message:" $ m.lcbody
  m.lcReason = ["The following recipients did not receive this message:" $ m.lcbody]
  m.lcStringToLookIn = m.lcBody
  m.lcStringPre = "this message:"
  m.lcStringDelim1 = "<"
  m.lcStringDelim2 = ">"
 othe
  m.lcReason = "Mail System Error but otherwise CASE"
 endcase

case m.lcSubject = "Returned mail:"
  m.lcReason = ["Returned mail:"]
  m.lcStringToLookIn = m.lcBody
  m.lcStringPre = ""
  m.lcStringDelim1 = "<"
  m.lcStringDelim2 = ">"

case m.lcSubject = "Undeliver:"
  m.lcStringPre = "To:"
  m.lcStringToLookIn = m.lcBody
  m.lcStringDelim1 = " "
  m.lcStringDelim2 = "chr(13) "
  m.lcReason = [Undeliverable]
 
 case m.lcSubject = "failure notice"
  m.lcStringPre = ""
  m.lcStringToLookIn = m.lcBody
  m.lcStringDelim1 = "<"
  m.lcStringDelim2 = ">"
  m.lcReason = [failure notice]

othe
 m.lcReason = "-- didn't test --"
endcase

replace BCCNAME with m.lcStringPre
replace BCCADDRESS with m.lcStringDelim1
replace BCCTYPE with m.lcStringDelim2
replace CCTYPE with m.lcReason

endscan && through EMAILBAD

select EMAILBAD

m.liNumTotalRecs = reccount()

scan 
wait window nowait "This many records to go: " + transform(m.liNumTotalRecs - recno())
 if m.lcReason <> "--"
  m.lcAddress = l_GetAddress(m.lcStringToLookIn, m.lcStringPre, m.lcStringDelim1, m.lcStringDelim2)
  m.lcReason2 = l_GetReason2(m.lcStringToLookIn, m.lcStringPre, m.lcStringDelim1, m.lcStringDelim2, m.lcReason)
  if empty(m.lcAddress)
    * didn't find an address in cBody or cSubject of EMAILBADADDR.DBF
    replace CCADDRESS with "Not found"
   if empty(m.lcReason2)
   else
    replace CCTYPE with "M" + alltrim(categories) + " " + m.lcReason2
   endif
  else
    replace CCADDRESS with m.lcAddress
  endif  
 else
  replace CCADDRESS with "-- didn't test --"
 endif
endscan

wait clear
return


********************************************************************
function l_GetAddress()
* 
lparameters m.tcStringToLookIn, m.tcStringPre, m.tcStringDelim1, m.tcStringDelim2
local m.lcStringToLookIn, m.lcStringPre, m.lcStringDelim1, m.lcStringDelim2, m.lcRetVal
m.lcStringToLookIn = lower(m.tcStringToLookIn)
m.lcStringPre = lower(m.tcStringPre)
m.lcStringDelim1 = m.tcStringDelim1
m.lcStringDelim2 = m.tcStringDelim2
m.lcRetVal = ""

m.llDebug1 = .f.
* look for tcStringPre in tcStringToLookIn and take last char
* if not found, last char = 1
* starting at last char, look for @ sign
* then make way to left, looking for tcStringDelim1 (if not empty) or a nonAZ09 char (if empty)
* then starting at @ sign again, make way to right with same search criteria

m.liPosFirstCharToStartLooking = at(m.lcStringPre, m.lcStringToLookIn) + len(alltrim(m.lcStringPre))
if m.liPosFirstCharToStartLooking = 0
 m.liPosFirstCharToStartLooking = 1
endif
m.lcStringToLookIn2 = substr(m.lcStringToLookIn, m.liPosFirstCharToStartLooking)
replace IMPORTANCE with m.lcStringToLookIn2
m.liPosOfAtSign = at("@", m.lcStringToLookIn2)
replace CATEGORIES with ;
 "D1:" + alltrim(m.lcStringDelim1) + ":" ;
 + "D2:" + alltrim(m.lcStringDelim2) + ":" ;
 + " At: " + transform(m.liPosOfAtSign)
m.liPosBegAddress = 1
m.liPosEndAddress = len(alltrim(m.lcStringToLookIn2))
if m.liPosOfAtSign = 0
 *\\\ no @ sign
 m.lcAddress = ""
else
 * got an @ sign. Now look backwards and forwards.
 *
 * backwards
 *
 if empty(m.lcStringDelim1)
  * starting at m.liPosOfAtSign in m.tcStringToLookIn2, look at each previous char
  * if it's AZ09, cool
  * else, we're at the beginning - mark the position
  for m.li = 1 to m.liPosOfAtSign
   m.lcCharToExamine = substr(m.lcStringToLookIn2, m.liPosOfAtSign - m.li, 1) 
   if m.lcCharToExamine $ "abcdefghijklmnopqrstuvwxyz1234567890_-."
    * it's a cool char
   else
    * we've found the beginning of the string 
    * (herm@abc.com where @ is 27, the delimiting space is 22 (m.li=5), so we want 23)
    * 27 - 5 + 1
    m.liPosBegAddress = m.liPosOfAtSign - m.li + 1
    exit
   endif
  next
  replace CATEGORIES with alltrim(CATEGORIES) + "-- Beg: " + transform(m.liPosBegAddress) + "--"
 else
  * starting at m.liPosOfAtSign in m.tcStringToLookIn2, look at each previous char
  * if it's cStringDelim1, we've got our mark!
  for m.li = 1 to m.liPosOfAtSign
   m.lcCharToExamine = substr(m.lcStringToLookIn2, m.liPosOfAtSign - m.li, 1) 
   if m.lcCharToExamine = m.lcStringDelim1 or empty(m.lcCharToExamine) or !(m.lcCharToExamine $ "abcdefghijklmnopqrstuvwxyz1234567890_-.")
    * we've found the beginning of the string 
    * (herm@abc.com where @ is 27, the delimiting space is 22 (m.li=5), so we want 23)
    * 27 - 5 + 1
    m.liPosBegAddress = m.liPosOfAtSign - m.li + 1
    exit
   else
    * not there yet
   endif
  next
  replace CATEGORIES with alltrim(CATEGORIES) + "-- Beg: " + transform(m.liPosBegAddress) + "--"
 endif && empty(m.lcStringDelim1)
 *
 * forwards
 *
 m.liHowManyToSearchForwardFor = len(m.lcStringToLookIn2) - m.liPosOfAtSign
 if empty(m.lcStringDelim2)
  * starting at m.liPosOfAtSign in m.tcStringToLookIn2, look at each previous char
  * if it's AZ09, cool
  * else, we're at the beginning - mark the position
  for m.li = 1 to m.liHowManyToSearchForwardFor
   m.lcCharToExamine = substr(m.lcStringToLookIn2, m.liPosOfAtSign + m.li, 1) 
   if m.lcCharToExamine $ "abcdefghijklmnopqrstuvwxyz1234567890_-."
    * it's a cool char
   else
    * we've found the end of the string 
    * (herm@abc.com where @ is 27, the delimiting space is 35 (m.li=8), so we want 34)
    * 27 + 8 - 1
    m.liPosEndAddress = m.liPosOfAtSign + m.li - 1
    exit
   endif
  next
  replace CATEGORIES with alltrim(CATEGORIES) + "-- End: " + transform(m.liPosEndAddress) + "--"
 else
  * starting at m.liPosOfAtSign in m.tcStringToLookIn2, look at each previous char
  * if it's cStringDelim1, we've got our mark!
  for m.li = 1 to m.liHowManyToSearchForwardFor
   m.lcCharToExamine = substr(m.lcStringToLookIn2, m.liPosOfAtSign + m.li, 1) 
   if m.lcCharToExamine = m.lcStringDelim2 or empty(m.lcCharToExamine) or !(m.lcCharToExamine $ "abcdefghijklmnopqrstuvwxyz1234567890_-.")
    * we've found the end of the string 
    * (herm@abc.com where @ is 27, the delimiting space is 35 (m.li=8), so we want 34)
    * 27 + 8 - 1
    m.liPosEndAddress = m.liPosOfAtSign + m.li - 1
    exit
   else
    * not there yet
   endif
  next
  replace CATEGORIES with alltrim(CATEGORIES) + "-- End: " + transform(m.liPosEndAddress) + "--"
 endif && empty(cStringDelim2)
 *
 * got the beg and end pos of the address (we think)
 *
 * End = 34, Beg = 23
 m.lcAddress = substr(m.lcStringToLookIn2, m.liPosBegAddress, m.liPosEndAddress - m.liPosBegAddress + 1)
 m.lcRetVal = m.lcAddress
endif
return m.lcRetVal

